#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <unistd.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <arpa/inet.h>
#include <sys/wait.h>

#include <netdb.h>
#include <unistd.h>
#include <fcntl.h>

#include <grp.h>
#include <pwd.h>
#include <errno.h>
#include <time.h>
#include <pthread.h>

#define PORT 2007	/*Ecoute sur le port 2007*/
#define LISTE_ATTENTE 5
#define MAX_CARACT 100 /*Limitation à 100 caractères par contacts*/
#define MAXCONTACTS 500 /*Limitation à 500 contacts*/
#define MAXCLIENTS 10000

#include "serveur_tcp.h"
#include "mesfonctions_serv.c"


int main ( void )
{
	/**Initialisation des variables + allocation de mémoire*/
	char *message;
	int nb_utilisateurs=0,i=0;
	connexion = malloc(MAX_CARACT+1);
	actualisation = malloc(MAX_CARACT+1);
	ip_client = malloc(MAX_CARACT+1);
	message = malloc(MAX_CARACT+1);
	connexion="non connecté";
	actualisation="pas d'actualisation";
	printf("DEBUT!!!!!!!!\n");
	
	/**Prépare le programme à des communications réseaux + Initialise les infos sur les clients*/
	init_socket();
	initialisation_infos_clients();
	
	while(1)
	{
		if (deconnexion(message))	nb_utilisateurs--; /**Vérifie si un client demande à se déconnecter*/
	
		/**Affiche la liste des clients connectés*/
		printf("\n#############LISTE DES CLIENTS CONNECTES##################\n");
		for (i=0;i<nb_utilisateurs;i++)	affiche_utilisateur_connecte(i);
		printf("\n##########################################################\n");
	
		/**Ecoute le réseau*/
		message=ecoute();	
		printf("\nl'ip : %s envoi : '%s'\n",ip_client,message);
	
		if (connection(message,nb_utilisateurs))	nb_utilisateurs++; /**Vérifie si un client demande à se connecter*/
		
		retransmission_message(message);	/**Vérifie si un client demande à transmettre un message*/
		
		vidage_client(nb_utilisateurs);/**Vide la pile*/
		
		actualise(message);	/**vérifie si un utilisateur cherche à s'actualiser*/
	}
	return EXIT_SUCCESS;
}


